<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Handler_FileCreator extends Controller_Handler
{

    public function before() {
        $this->model = new Model_Teacher_Rating;
        $this->setAccessLevel(self::ACCESS_USER);
        parent::before();
    }
    
    // Таблица баллов (со страницы оценивания) [dev version]
    public function action_GenerateExcelRatingTable()
    {
        // TODO CHECK!!!

            $xls = new PHPExcel();

            // Устанавливаем индекс активного листа
            $xls->setActiveSheetIndex(0);

            // Получаем активный лист
            $sheet = $xls->getActiveSheet();


            // Шапка таблицы: структура УКД (модули и мероприятия)
            $structure = $this->model->GetMapForDiscipline($this->user['TeacherID'], $this->post->offsetGet('disciplineID'));

            $structureHandled = array();
            $maxRate = 0; $i = 0; $module = 0;

            foreach($structure as $row)
            {
                if($row['ModuleID'] != $module)
                {
                    $i++;
                    $module = $row['ModuleID'];
                }
                if(!isset($structureHandled[$i]['SubmodulesCount']))
                {
                    $structureHandled[$i]['SubmodulesCount'] = 0;
                    $structureHandled[$i]['MaxRate'] = 0;
                }
                $j = $structureHandled[$i]['SubmodulesCount'] += 1;
                $structureHandled[$i]['MaxRate'] += (int) $row['MaxRate'];
                $structureHandled[$i]['ModuleTitle'] = $row['ModuleName'];
                $structureHandled[$i]['ModuleType'] = $row['ModuleType'];
                        
                $structureHandled[$i][$j]['SubmoduleID'] = $row['SubmoduleID'];
                $structureHandled[$i][$j]['Title'] = $row['SubModuleName'];

                $structureHandled[$i][$j]['MaxRate'] = (int) $row['MaxRate'];
                $maxRate += $row['MaxRate'];
            }
            $structureHandled['ModulesCount'] = $i;
            $structureHandled['MaxRate'] = (int) $maxRate;

            $sheet->setCellValueByColumnAndRow(
                0, // Столбец. Индексация с 0
                1, // Строка. Индексация с 1
                'Модуль'
            );

            $sheet->setCellValueByColumnAndRow(
                0,
                2,
                'Мероприятие'
            );

            $sheet->setCellValueByColumnAndRow(
                0,
                3,
                'Макс. балл'
            );

            $SubmodulesCount = 0;
            // Модули
            for ($k = 1; $k <=  $structureHandled['ModulesCount']; $k++)
            {
                if ($k == 1) $pointer = 1;

                $sheet->mergeCellsByColumnAndRow($pointer, 1, $pointer + $structureHandled[$k]['SubmodulesCount'] - 1, 1);

                $sheet->setCellValueByColumnAndRow(
                    $pointer,
                    1,
                    $structureHandled[$k]['ModuleTitle']
                );

                $l = 0;
                // Мероприятия
                for ($l = 1; $l <= $structureHandled[$k]['SubmodulesCount']; $l++)
                {
                    $sheet->setCellValueByColumnAndRow(
                        $pointer + $l - 1,
                        2,
                        $structureHandled[$k][$l]['Title']
                    );

                    $sheet->setCellValueByColumnAndRow(
                        $pointer + $l - 1,
                        3,
                        $structureHandled[$k][$l]['MaxRate']
                    );
                    $SubmodulesCount++;
                }

                $pointer = $structureHandled[$k]['SubmodulesCount'] + 1;
            }

            $sheet->setCellValueByColumnAndRow(
                $SubmodulesCount + 1,
                1,
                'Итог'
            );

            $sheet->mergeCellsByColumnAndRow( $SubmodulesCount + 1, 1,  $SubmodulesCount + 1, 3 );

            // Студенты и их баллы
            $students = $this->model->GetStudentsForRating($this->user['TeacherID'], $this->post->offsetGet('disciplineID'));

            $i_s = 0; $curGroup = 0; $ratesum = 0;

            foreach($students as $row) {
                if ($curGroup !== $row['GroupID']) {
                    $curGroup = $row['GroupID'];
                    $i_s++;
                    $sheet->mergeCellsByColumnAndRow( 0, 3 + $i_s,  $SubmodulesCount + 1, 3 + $i_s );
                    $sheet->setCellValueByColumnAndRow(
                        0,
                        3 + $i_s,
                        $row['GroupNum']." группа"
                    );
                }
                // Студенты
                $i_s++;
                $ratesum += $r['Rate'];

                $sheet->setCellValueByColumnAndRow(
                    0,
                    3 + $i_s,
                    $row['Last'].' '.$row['First'].' '.$row['Second']
                );

                // Баллы студента
                $rate = $this->model->getMapForStudent($row['ID'], $this->post->offsetGet('disciplineID'));
                $i_r = 0;
                foreach($rate as $r) {
                    $i_r++;
                    $sheet->setCellValueByColumnAndRow(
                        $i_r,
                        3 + $i_s,
                        $r['Rate']
                    );
                }

                $sheet->setCellValueByColumnAndRow(
                    $SubmodulesCount + 1, // Столбец. Индексация с 0
                    3 + $i_s,
                    $ratesum
                );

            }

            $this->GetHeaders();
             
            // Выводим содержимое файла
            $objWriter = new PHPExcel_Writer_Excel5($xls);
            $objWriter->save('php://output');
    }

    // Ведомость
    public function action_GenerateFinalForm()
    {
        // TODO CHECK!!! // TODO      
		// parameters
        $disciplineID = $this->post->offsetGet('disciplineID');
        $groupID = $this->post->offsetGet('studyGroupID');
		
		// preparation
        $db = $this->model;
        $info = $db->getFinalFormInfo($disciplineID, $groupID);
		
       
        $type = $info[0]['ExamType'];
        $templateFile = DOCROOT."docs/template $type.xls";
        if (!file_exists($templateFile)) {
            exit("template wasn't found" . PHP_EOL); // TODO
        }
        $objPHPExcel = PHPExcel_IOFactory::load($templateFile);
        $objPHPExcel->setActiveSheetIndex(0);
		        
        // $specName = '';  <------- TODO
		$this->printDisciplineToExcelFile($objPHPExcel, $disciplineID, $groupID, $info[0]);
		$grade = $info[0]["GradeNum"];
		$group = $info[0]["GroupNum"];
        //$this->GetHeaders("FinalForm".$disciplineID."_".$groupID);
		$this->GetHeaders("FinalForm_".$grade."_".$group);
        $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
        $objWriter->save('php://output');
    } 
	
    public function printDisciplineToExcelFile(&$objPHPExcel, $disciplineID, $groupID, $headerData) {
		
        // preparation
        $type = $headerData['ExamType'];
        $db = $this->model;
        $result = $db->getRatesForStudentsGroup($this->user['TeacherID'], $disciplineID, $groupID);
        $rates = $db->getAttestationData($disciplineID, $groupID);

        // fill header
        $this->prepareSheetHeader($objPHPExcel, $type, $headerData);
                
        // fill students rows
        $startRow = 12;
        $rowNumber = $startRow;
        $index = 1;
		
		$examHold = $this->checkExamIsHold($result);

        $i=0;
        foreach($result as $studentInfo){
            while ($rates[$i]['Type'] == 'extra' && $rates[$i]['StudentID'] == $studentInfo['ID']) {
                $orderNum = $rates[$i]['OrderNum'];
                $studentInfo['Attempt'][$orderNum]['ExtraRate'] = (int)$rates[$i]['Rate'];
                $i++;
            }
            while ($rates[$i]['Type'] == 'exam' && $rates[$i]['StudentID'] == $studentInfo['ID']) {
                $orderNum = $rates[$i]['OrderNum'];
                $studentInfo['Attempt'][$orderNum]['ExamRate'] = (int)$rates[$i]['Rate'];
                if (($timestamp = strtotime($rates[$i]['Date'])) == false)
                    $date = '';
                else
                    $date = date("d.m.y", $timestamp);
                $studentInfo['Attempt'][$orderNum]['ExamDate'] = $date;
                $i++;
            }
		    $this->addStudentToSheet($objPHPExcel, $type, $studentInfo, $rowNumber, $index, $examHold);
            $rowNumber++;
            $index++;				
        }
    }

    protected function prepareSheetHeader(&$objPHPExcel, $disciplineType, $data) {
        $sheet = $objPHPExcel->getActiveSheet();
        
        $range = $objPHPExcel->getNamedRange("Discipline")->getRange();
        $sheet->setCellValue($range, $data['SubjectName']);
        $range = $objPHPExcel->getNamedRange("Group")->getRange();
        $sheet->setCellValue($range, $data['GroupNum']);
        $range = $objPHPExcel->getNamedRange("Subdivision")->getRange();
        $sheet->setCellValue($range, $data['FacultyName']);
        $range = $objPHPExcel->getNamedRange("Major")->getRange();  
        $sheet->setCellValue($range, "Специальность: ".$data['SpecName']." ".$data['SpecCode']);
        $range = $objPHPExcel->getNamedRange("Teacher")->getRange();
        $sheet->setCellValue($range, $data['LastName']." ".$data['FirstName']." ".$data['SecondName']);
		
        $range = $objPHPExcel->getNamedRange("Grade")->getRange();
		$degree = $data['Degree'];
        $gradeNum =  $data['GradeNum'];
		$gradeName = $gradeNum;
		if ($degree == 'master')
			$gradeName = $gradeName."м";
        $sheet->setCellValue($range, $gradeName);
		
        $range = $objPHPExcel->getNamedRange("Semester")->getRange();
        $semester = $data['SemesterNum'] + ($gradeNum -1)*2;
        $sheet->setCellValue($range, $semester);

        $range = $objPHPExcel->getNamedRange("Year")->getRange();
        $sheet->setCellValue($range, $data['Year']);
        $range = $objPHPExcel->getNamedRange("CreationDate")->getRange();
        $sheet->setCellValue($range, date("d.m.y"));
        
        $range = $objPHPExcel->getNamedRange("Date")->getRange();
        if ($disciplineType == 'credit') {
            $controlDate = "Дата зачета\n30.12.2014";
        } elseif ($disciplineType == 'exam') {
            $controlDate = "Дата экзамена\n__________";
        }
        $sheet->setCellValue("$range", $controlDate);
    }

    protected function addStudentToSheet(&$objPHPExcel, $disciplineType, $data, $row, $index, $examHold1)
    {
        $sheet = $objPHPExcel->getActiveSheet();
        if ($disciplineType == 'credit') {
            $this->addStudentInfoForCreditToSheet($sheet, $data, $row, $index);
        } elseif ($disciplineType == 'exam') {
		    $this->addStudentInfoForExamToSheet($sheet, $data, $row, $index, $examHold1);
        }
    }

    protected function addStudentInfoForCreditToSheet(&$sheet, $data, $row, $index)
    {
        $indPosition = 'A'; // Номер
        $namePosition = 'B';  // ФИО
        $totalRatePosition = 'G';  // Итоговый рейтинг
        $semesterRatePosition  = 'H';   // Сумма баллов
        $bonusRatePosition = 'I'; // Бонусные баллы
        $datePosition = array('*', 'N', 'R'); // Добор
        $extraRatePosition = array('*', 'L', 'P'); // Добор
        $stringRatePosition = array('J', 'M', 'Q'); // Оценка вида зачтено/не зачтено

        $sheet  ->getStyle("A".$row.":S".$row)
                ->getBorders()->getAllBorders()
                ->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN);
        $sheet  ->getStyle("G".$row.":S".$row)
                ->getAlignment()
                ->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);
        $sheet->mergeCells("B".$row.":F".$row);

        $lastName = $data['Last'];
        $firstName = $data['First'];
        $secondName = $data['Second'];
        $semesterRate = (int)$data['intermediate'];
        $bonus = (int)$data['bonus'];
        $fullName = $lastName." ".$firstName." ".$secondName;
        $rateForCredit = $semesterRate;

        $sheet  ->setCellValue($indPosition.$row, $index)
            ->setCellValue($namePosition.$row, $fullName)
            ->setCellValue($semesterRatePosition.$row, $semesterRate)
            ->setCellValue($bonusRatePosition.$row, $bonus);

        $i=0;
        $rateToShow = 0;
        do {
            if (!$data['Attempt'][$i+1]['ExamDate'])
                continue;

            if ($i == 0)
                $extra = 0;
            else {
                $extra = $data['Attempt'][$i]['ExtraRate'];
                $sheet->setCellValue($datePosition[$i].$row, $data['Attempt'][$i]['Date'])
                    ->setCellValue($extraRatePosition[$i].$row, $extra);
            }

            $rateForCredit += $extra;
            $totalRate = $rateForCredit + $bonus;
			if ($totalRate > 100)
				$totalRate = 100;

            if($rateForCredit < 60) {
                    $rateToShow = "";
                    $tempStr = "не зачтено";
            } else {
                    $rateToShow = $totalRate;
                    $tempStr = "зачтено";
            }

            $sheet->setCellValue($stringRatePosition[$i].$row, $tempStr);
            if ($rateToShow)
                break;

        } while(++$i<3);
        $sheet->setCellValue($totalRatePosition.$row, $rateToShow);

    }

    protected function addStudentInfoForExamToSheet(&$sheet, $data, $row, $index, $examHold)
    {
        $indPosition = 'A'; // Номер
        $namePosition = 'B';  // ФИО
        $totalRatePosition = 'H';  // Итоговый рейтинг
        $semesterRatePosition  = 'I';   // Сумма баллов
        $bonusRatePosition = 'J'; // Бонусные баллы
        $extraRatePosition = 'N'; // Добор
        $examRatePosition = array('K', 'O', 'S') ; // Баллы за экзамен
        $rateOfFivePosition = array ('L', 'P', 'T'); // Оценка за экзамен по пятибальной системе
        $datePosition = array ('*', 'Q', 'U'); // Дата экзамена

        $sheet  ->getStyle("A".$row.":V".$row)
            ->getBorders()->getAllBorders()
            ->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN);
        $sheet  ->getStyle("H".$row.":K".$row)
            ->getAlignment()
            ->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $sheet  ->getStyle("L".$row.":M".$row)
            ->getAlignment()
            ->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);
        $sheet  ->getStyle("N".$row.":O".$row)
            ->getAlignment()
            ->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $sheet  ->getStyle("P".$row.":V".$row)
            ->getAlignment()
            ->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);
        $sheet  ->getStyle("S".$row.":S".$row)
            ->getAlignment()
            ->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
        $sheet->mergeCells("B".$row.":G".$row);

        $lastName = $data['Last'];
        $firstName = $data['First'];
        $secondName = $data['Second'];
        $semesterRate = (int)$data['intermediate'];
        $bonus = (int)$data['bonus'];
        $fullName = $lastName." ".$firstName." ".$secondName;
        $examAdmission = $semesterRate;

        $sheet  ->setCellValue($indPosition.$row, $index)
            ->setCellValue($namePosition.$row, $fullName)
            ->setCellValue($semesterRatePosition.$row, $semesterRate)
            ->setCellValue($bonusRatePosition.$row, $bonus);

        $i=0;
        do {
            if (!$data['Attempt'][$i+1]['ExamDate'])
                continue;

            $examRateValue = $data['Attempt'][$i+1]['ExamRate'];
            if ($i == 0)
                $extra = 0;
            else {
                $extra = $data['Attempt'][1]['ExtraRate'];
                $sheet->setCellValue($datePosition[$i].$row, $data['Attempt'][$i+1]['ExamDate'])
                    ->setCellValue($extraRatePosition.$row, $extra);
                $examAdmission += $extra;
            }

            $total = $examAdmission+$examRateValue+$bonus;
            list($totalRateStr, $rateOfFive, $examRateStr) =
                $this->formRateOfFive($examAdmission, $examRateValue, $total, $examHold);

            $sheet->setCellValue($examRatePosition[$i].$row, $examRateStr)
                ->setCellValue($rateOfFivePosition[$i].$row, $rateOfFive);
            if ($totalRateStr)
                break;

        } while(++$i<3);
        $sheet->setCellValue($totalRatePosition.$row, $totalRateStr);
    }
	
    protected function getSheetName(&$disciplineInfo) {
        $str = $disciplineInfo['SubjectAbbr'];
        if (empty($str)) {
            $str = $disciplineInfo['SubjectName'];
        }
        //$str = preg_replace('/[^A-Za-z0-9\-]/', '', $str);
        return substr($str, 0, 10);
    }
	
    public function action_GenerateFinalFormsForGroup() {
        // parameters
        //$gradeID = $this->post->offsetGet('gradeID');
        $groupID = $this->post->offsetGet('GroupID');

        // preparation
        $db = $this->model;
        $listDisciplines = $db->GetDisciplinesForGroup($groupID);

        $templateFile = DOCROOT."docs/template credit.xls";
        if (!file_exists($templateFile)) {
                exit("template wasn't found" . PHP_EOL); // TODO
        }
        $objPHPExcel = PHPExcel_IOFactory::load($templateFile);
        // Make copy of sheet
        $sheetTemplate = $objPHPExcel->getActiveSheet()->copy();
        // Make copy of named ranges
        $nmrange = $objPHPExcel->getNamedRanges() ; 

        $index = 0;
        foreach ($listDisciplines as $record) {
                $disciplineID = $record['DisciplineID'];
                $info = $db->getFinalFormInfo($disciplineID, $groupID);

                $type = $info[0]['ExamType'];
                if ($type == 'exam') {
                continue;
            }

            if ($index > 0) {
                        // remove name ranges from active page
                        foreach ($objPHPExcel->getNamedRanges() as $name => $r )
                        {
                                $objPHPExcel -> removeNamedRange ($r->getName(), null);
                        }	
                        //make clone from page copy and include it in workbook
                        $C = clone $sheetTemplate;
                        try {
                            $C->setTitle($this->getSheetName($info[0]));
                        } catch (Exception $ex) {
                            $C->setTitle("Без_имени_".$index);
                        }  
                       
                        $objPHPExcel->addSheet($C,$index);
                        $objPHPExcel->setActiveSheetIndex($index);
                        // create name ranges at new sheet 
                        foreach ($nmrange as $namedRange) {
                                $name = $namedRange->getName();
                                $rg = $namedRange->getRange();
                                $objPHPExcel->addNamedRange(new PHPExcel_NamedRange($name, $objPHPExcel->getActiveSheet(),$rg));
                        }
                }
                else
                {   
                    try {
                        $objPHPExcel->setActiveSheetIndex($index)->setTitle($this->getSheetName($info[0]));
                    } catch (Exception $ex) {
                        $objPHPExcel->setActiveSheetIndex($index)->setTitle("Без_имени_".$index);
                    }        
                    $gradeNum = $info[0]['GradeNum'];
                    $groupNum = $info[0]['GroupNum'];
                }

                $this->printDisciplineToExcelFile($objPHPExcel, $disciplineID, $groupID, $info[0]);
                $index++;
        }
        
        if ($index === 0) {
            throw HTTP_Exception::factory(400);
            return;
        }

        $this->GetHeaders("FinalForm_".$gradeNum."_".$groupNum);
        $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');
        $objWriter->save('php://output');
    }
	
    // Выводим HTTP-заголовки
    public function GetHeaders($filename = 'excel')
    {
        $this->response->headers("Last-Modified", gmdate("D,d M YH:i:s") . " GMT" );
        $this->response->headers( "Cache-Control", " no-cache, must-revalidate" );
        $this->response->headers("Pragma", " no-cache" );
        $this->response->headers("Content-type", " application/vnd.ms-excel" );
        $this->response->headers("Content-Disposition", "attachment; filename=".$filename.".xls" );
    }
	
	protected function checkExamIsHold(&$studentsRates) 
	{
		foreach($studentsRates as $studentInfo){
            if ($studentInfo['exam'] >= 0)
				return 1;
        } 
		return 0;
	}

    // Определяет оценку по пятибальной системе
    protected function formRateOfFive($examAdmission, $examRateValue, $totalRateValue, $examHold)
    {
        if ($totalRateValue > 100)
            $totalRateValue = 100;
        $totalRateStr = '';
        $rateOfFive = '';
		$examRateStr = '';
        if ($examHold != 0) 
		{
			$examRateStr = $examRateValue;
			if (($examAdmission < 38) or ($examRateValue < 22)) {
				$rateOfFive = 'неуд';
			} else {
				$totalRateStr = $totalRateValue;
				$rateOfFive = 'удовл';
				if (($totalRateValue >= 71) and ($totalRateValue < 85))
					$rateOfFive = 'хор';
				elseif ($totalRateValue >= 85)
					$rateOfFive = 'отл';
			}
		}
		else
		{		
			if ($examAdmission < 38) { // задолженник
				//$totalRateStr = ' ';
				$rateOfFive = 'неуд';
				$examRateStr = '0';
			} 
		}
        
        return array($totalRateStr, $rateOfFive, $examRateStr);
    }

}